using Vo;
using Microsoft.AspNetCore.Mvc;
using Model;
using Services;
using Model.Base;
using Vo.Admin;
using Mapster;
using Infrastructure;


namespace Controllers.Admin
{
    /// <summary>
    /// PriCondition)Controller
    /// </summary>
    // [ApiExplorerSettings(GroupName = "PriCondition")]
    public class PriConditionController : BaseController
    {
        /// <summary>
        /// api分组接口
        /// </summary>
        private readonly IPriConditionService _PriConditionService;


        public PriConditionController(IPriConditionService PriConditionService)
        {
            _PriConditionService = PriConditionService;

        }

          /// <param name="page">分页参数</param>
        /// <summary>
        /// 列表
        /// </summary>
        /// <param name="page">分页对象</param>
        /// <param name="param">参数请求体</param>
        /// <returns>列表</returns>
        [HttpGet]
        [Route("/v1/pri/PriCondition/getPriConditionList")]
        public IActionResult getPriConditionList([FromQuery] PagerInfo page, [FromQuery] PriCondition param)
        {
            var response = _PriConditionService.getPriConditionList(page, param);
            return SUCCESS(response);
        }


        /// <summary>
        /// 详情
        /// </summary>
        /// <param name="param">参数请求体</param>
        /// <returns>详情</returns>
        [HttpGet]
        [Route("/v1/pri/PriCondition/getPriConditionQuery")]
        public IActionResult getPriConditionQuery([FromQuery] PriCondition param)
        {
            var response = _PriConditionService.GetFirst(m => m.id == param.id).Adapt<GetPriConditionQueryVo>();
            return SUCCESS(response);
        }


        /// <summary>
        /// 添加
        /// </summary>
        /// <param name="param">参数请求体</param>
        /// <returns>添加</returns>
        [HttpPost]
        [Route("/v1/pri/PriCondition/addPriCondition")]
        public IActionResult addPriCondition([FromBody] PriCondition param)
        {
            var modal = param.Adapt<PriCondition>().ToCreate(HttpContext);
            var response = _PriConditionService.Add(modal);
            return SUCCESS(response);
        }


        /// <summary>
        /// 修改
        /// </summary>
        /// <param name="param">参数请求体</param>
        /// <returns>修改</returns>
        [HttpPut]
        [Route("/v1/pri/PriCondition/updatePriCondition")]
        public IActionResult updatePriCondition([FromBody] PriCondition param)
        {
            var modal = param.Adapt<PriCondition>().ToCreate(HttpContext);
            var response = _PriConditionService.Update(modal);
            return SUCCESS(response);
        }


        /// <summary>
        /// 删除
        /// </summary>
        /// <param name="id">ID</param>
        /// <returns>删除</returns>
        [HttpDelete]
        [Route("/v1/pri/PriCondition/deletePriCondition/{id}")]
        public IActionResult deletePriCondition(int id)
        {
            var response = _PriConditionService.Delete(id);
            return SUCCESS(response);
        }




    }
}