using Vo;
using Microsoft.AspNetCore.Mvc;
using Model;
using Services;
using Model.Base;
using Vo.Admin;
using Mapster;
using Infrastructure;
using Common;


namespace Controllers.Admin
{
    /// <summary>
    /// PriLog)Controller
    /// </summary>
    // [ApiExplorerSettings(GroupName = "PriLog")]
    public class PriLogController : BaseController
    {
        /// <summary>
        /// api分组接口
        /// </summary>
        private readonly IPriLogService _PriLogService;


        public PriLogController(IPriLogService PriLogService)
        {
            _PriLogService = PriLogService;

        }

          /// <param name="page">分页参数</param>
        /// <summary>
        /// 列表
        /// </summary>
        /// <param name="page">分页对象</param>
        /// <param name="param">参数请求体</param>
        /// <returns>列表</returns>
        [HttpGet]
        [Route("/v1/pri/PriLog/getPriLogList")]
        public IActionResult getPriLogList([FromQuery] PagerInfo page, [FromQuery] PriLog param)
        {
            var response = _PriLogService.getPriLogList(page, param);
            return SUCCESS(response);
        }


        /// <summary>
        /// 详情
        /// </summary>
        /// <param name="param">参数请求体</param>
        /// <returns>详情</returns>
        [HttpGet]
        [Route("/v1/pri/PriLog/getPriLogQuery")]
        public IActionResult getPriLogQuery([FromQuery] PriLog param)
        {
            var response = _PriLogService.GetFirst(m => m.id == param.id).Adapt<GetPriLogQueryVo>();
            response.stepList = "{" + Function.CheckNull(response.stepList).TrimEnd(',') + "}";
            return SUCCESS(response);
        }


        /// <summary>
        /// 添加
        /// </summary>
        /// <param name="param">参数请求体</param>
        /// <returns>添加</returns>
        [HttpPost]
        [Route("/v1/pri/PriLog/addPriLog")]
        public IActionResult addPriLog([FromBody] PriLog param)
        {
            var modal = param.Adapt<PriLog>().ToCreate(HttpContext);
            var response = _PriLogService.Add(modal);
            return SUCCESS(response);
        }


        /// <summary>
        /// 修改
        /// </summary>
        /// <param name="param">参数请求体</param>
        /// <returns>修改</returns>
        [HttpPut]
        [Route("/v1/pri/PriLog/updatePriLog")]
        public IActionResult updatePriLog([FromBody] PriLog param)
        {
            var modal = param.Adapt<PriLog>().ToCreate(HttpContext);
            var response = _PriLogService.Update(modal);
            return SUCCESS(response);
        }


        /// <summary>
        /// 删除
        /// </summary>
        /// <param name="id">ID</param>
        /// <returns>删除</returns>
        [HttpDelete]
        [Route("/v1/pri/PriLog/deletePriLog/{id}")]
        public IActionResult deletePriLog(int id)
        {
            var response = _PriLogService.Delete(id);
            return SUCCESS(response);
        }




    }
}