using Vo;
using Microsoft.AspNetCore.Mvc;
using Model;
using Services;
using Model.Base;
using Vo.Admin;
using Mapster;
using Infrastructure;


namespace Controllers.Admin
{
    /// <summary>
    /// PriPrizeInQueryField)Controller
    /// </summary>
    // [ApiExplorerSettings(GroupName = "PriPrizeInQueryField")]
    public class PriPrizeInQueryFieldController : BaseController
    {
        /// <summary>
        /// api分组接口
        /// </summary>
        private readonly IPriPrizeInQueryFieldService _PriPrizeInQueryFieldService;


        public PriPrizeInQueryFieldController(IPriPrizeInQueryFieldService PriPrizeInQueryFieldService)
        {
            _PriPrizeInQueryFieldService = PriPrizeInQueryFieldService;

        }

          /// <param name="page">分页参数</param>
        /// <summary>
        /// 列表
        /// </summary>
        /// <param name="page">分页对象</param>
        /// <param name="param">参数请求体</param>
        /// <returns>列表</returns>
        [HttpGet]
        [Route("/v1/pri/PriPrizeInQueryField/getPriPrizeInQueryFieldList")]
        public IActionResult getPriPrizeInQueryFieldList([FromQuery] PagerInfo page, [FromQuery] PriPrizeInQueryField param)
        {
            var response = _PriPrizeInQueryFieldService.getPriPrizeInQueryFieldList(page, param);
            return SUCCESS(response);
        }


        /// <summary>
        /// 详情
        /// </summary>
        /// <param name="param">参数请求体</param>
        /// <returns>详情</returns>
        [HttpGet]
        [Route("/v1/pri/PriPrizeInQueryField/getPriPrizeInQueryFieldQuery")]
        public IActionResult getPriPrizeInQueryFieldQuery([FromQuery] PriPrizeInQueryField param)
        {
            var response = _PriPrizeInQueryFieldService.GetFirst(m => m.id == param.id).Adapt<GetPriPrizeInQueryFieldQueryVo>();
            return SUCCESS(response);
        }


        /// <summary>
        /// 添加
        /// </summary>
        /// <param name="param">参数请求体</param>
        /// <returns>添加</returns>
        [HttpPost]
        [Route("/v1/pri/PriPrizeInQueryField/addPriPrizeInQueryField")]
        public IActionResult addPriPrizeInQueryField([FromBody] PriPrizeInQueryField param)
        {
            var modal = param.Adapt<PriPrizeInQueryField>().ToCreate(HttpContext);
            var response = _PriPrizeInQueryFieldService.Add(modal);
            return SUCCESS(response);
        }


        /// <summary>
        /// 修改
        /// </summary>
        /// <param name="param">参数请求体</param>
        /// <returns>修改</returns>
        [HttpPut]
        [Route("/v1/pri/PriPrizeInQueryField/updatePriPrizeInQueryField")]
        public IActionResult updatePriPrizeInQueryField([FromBody] PriPrizeInQueryField param)
        {
            var modal = param.Adapt<PriPrizeInQueryField>().ToCreate(HttpContext);
            var response = _PriPrizeInQueryFieldService.Update(modal);
            return SUCCESS(response);
        }


        /// <summary>
        /// 删除
        /// </summary>
        /// <param name="id">ID</param>
        /// <returns>删除</returns>
        [HttpDelete]
        [Route("/v1/pri/PriPrizeInQueryField/deletePriPrizeInQueryField/{id}")]
        public IActionResult deletePriPrizeInQueryField(int id)
        {
            var response = _PriPrizeInQueryFieldService.Delete(id);
            return SUCCESS(response);
        }




    }
}