using Vo;
using Microsoft.AspNetCore.Mvc;
using Model;
using Services;
using Model.Base;
using Vo.Admin;
using Mapster;
using Infrastructure;


namespace Controllers.Admin
{
    /// <summary>
    /// PriPrizeInSet)Controller
    /// </summary>
    // [Route("${Router}$")]
    // [ApiExplorerSettings(GroupName = "PriPrizeInSet")]
    public class PriPrizeInSetController : BaseController
    {
        /// <summary>
        /// api分组接口
        /// </summary>
        private readonly IPriPrizeInSetService _PriPrizeInSetService;


        public PriPrizeInSetController(IPriPrizeInSetService PriPrizeInSetService)
        {
            _PriPrizeInSetService = PriPrizeInSetService;

        }

          /// <param name="page">分页参数</param>
        /// <summary>
        /// 列表
        /// </summary>
        /// <param name="page">分页对象</param>
        /// <param name="param">参数请求体</param>
        /// <returns>列表</returns>
        [HttpGet]
        [Route("/v1/pri/PriPrizeInSet/getPriPrizeInSetList")]
        public IActionResult getPriPrizeInSetList([FromQuery] PagerInfo page, [FromQuery] PriPrizeInSet param)
        {
            var response = _PriPrizeInSetService.getPriPrizeInSetList(page, param);
            return SUCCESS(response);
        }


        /// <summary>
        /// 详情
        /// </summary>
        /// <param name="param">参数请求体</param>
        /// <returns>详情</returns>
        [HttpGet]
        [Route("/v1/pri/PriPrizeInSet/getPriPrizeInSetQuery")]
        public IActionResult getPriPrizeInSetQuery([FromQuery] PriPrizeInSet param)
        {
            var response = _PriPrizeInSetService.GetFirst(m => m.id == param.id).Adapt<GetPriPrizeInSetQueryVo>();
            return SUCCESS(response);
        }


        /// <summary>
        /// 添加
        /// </summary>
        /// <param name="param">参数请求体</param>
        /// <returns>添加</returns>
        [HttpPost]
        [Route("/v1/pri/PriPrizeInSet/addPriPrizeInSet")]
        public IActionResult addPriPrizeInSet([FromBody] PriPrizeInSet param)
        {
            var modal = param.Adapt<PriPrizeInSet>().ToCreate(HttpContext);
            var response = _PriPrizeInSetService.Add(modal);
            return SUCCESS(response);
        }


        /// <summary>
        /// 修改
        /// </summary>
        /// <param name="param">参数请求体</param>
        /// <returns>修改</returns>
        [HttpPut]
        [Route("/v1/pri/PriPrizeInSet/updatePriPrizeInSet")]
        public IActionResult updatePriPrizeInSet([FromBody] PriPrizeInSet param)
        {
            var modal = param.Adapt<PriPrizeInSet>().ToCreate(HttpContext);
            var response = _PriPrizeInSetService.Update(modal);
            return SUCCESS(response);
        }


        /// <summary>
        /// 删除
        /// </summary>
        /// <param name="id">ID</param>
        /// <returns>删除</returns>
        [HttpDelete]
        [Route("/v1/pri/PriPrizeInSet/deletePriPrizeInSet/{id}")]
        public IActionResult deletePriPrizeInSet(int id)
        {
            var response = _PriPrizeInSetService.Delete(id);
            return SUCCESS(response);
        }




    }
}