using Vo;
using Microsoft.AspNetCore.Mvc;
using Model;
using Services;
using Model.Base;
using Vo.Admin;
using Mapster;
using Infrastructure;


namespace Controllers.Admin
{
    /// <summary>
    /// PriProjectParam)Controller
    /// </summary>
    // [ApiExplorerSettings(GroupName = "PriProjectParam")]
    public class PriProjectParamController : BaseController
    {
        /// <summary>
        /// api分组接口
        /// </summary>
        private readonly IPriProjectParamService _PriProjectParamService;


        public PriProjectParamController(IPriProjectParamService PriProjectParamService)
        {
            _PriProjectParamService = PriProjectParamService;

        }

          /// <param name="page">分页参数</param>
        /// <summary>
        /// 列表
        /// </summary>
        /// <param name="page">分页对象</param>
        /// <param name="param">参数请求体</param>
        /// <returns>列表</returns>
        [HttpGet]
        [Route("/v1/pri/PriProjectParam/getPriProjectParamList")]
        public IActionResult getPriProjectParamList([FromQuery] PagerInfo page, [FromQuery] PriProjectParam param)
        {
            var response = _PriProjectParamService.getPriProjectParamList(page, param);
            return SUCCESS(response);
        }


        /// <summary>
        /// 详情
        /// </summary>
        /// <param name="param">参数请求体</param>
        /// <returns>详情</returns>
        [HttpGet]
        [Route("/v1/pri/PriProjectParam/getPriProjectParamQuery")]
        public IActionResult getPriProjectParamQuery([FromQuery] PriProjectParam param)
        {
            var response = _PriProjectParamService.GetFirst(m => m.id == param.id).Adapt<GetPriProjectParamQueryVo>();
            return SUCCESS(response);
        }


        /// <summary>
        /// 添加
        /// </summary>
        /// <param name="param">参数请求体</param>
        /// <returns>添加</returns>
        [HttpPost]
        [Route("/v1/pri/PriProjectParam/addPriProjectParam")]
        public IActionResult addPriProjectParam([FromBody] PriProjectParam param)
        {
            var modal = param.Adapt<PriProjectParam>().ToCreate(HttpContext);
            var response = _PriProjectParamService.Add(modal);
            return SUCCESS(response);
        }


        /// <summary>
        /// 修改
        /// </summary>
        /// <param name="param">参数请求体</param>
        /// <returns>修改</returns>
        [HttpPut]
        [Route("/v1/pri/PriProjectParam/updatePriProjectParam")]
        public IActionResult updatePriProjectParam([FromBody] PriProjectParam param)
        {
            var modal = param.Adapt<PriProjectParam>().ToCreate(HttpContext);
            var response = _PriProjectParamService.Update(modal);
            return SUCCESS(response);
        }


        /// <summary>
        /// 删除
        /// </summary>
        /// <param name="id">ID</param>
        /// <returns>删除</returns>
        [HttpDelete]
        [Route("/v1/pri/PriProjectParam/deletePriProjectParam/{id}")]
        public IActionResult deletePriProjectParam(int id)
        {
            var response = _PriProjectParamService.Delete(id);
            return SUCCESS(response);
        }




    }
}