using Vo;
using Microsoft.AspNetCore.Mvc;
using Model;
using Services;
using Model.Base;
using Vo.Admin;
using Mapster;
using Infrastructure;


namespace Controllers.Admin
{
    /// <summary>
    /// PriQueryTable)Controller
    /// </summary>
    // [ApiExplorerSettings(GroupName = "PriQueryTable")]
    public class PriQueryTableController : BaseController
    {
        /// <summary>
        /// api分组接口
        /// </summary>
        private readonly IPriQueryTableService _PriQueryTableService;


        public PriQueryTableController(IPriQueryTableService PriQueryTableService)
        {
            _PriQueryTableService = PriQueryTableService;

        }

          /// <param name="page">分页参数</param>
        /// <summary>
        /// 列表
        /// </summary>
        /// <param name="page">分页对象</param>
        /// <param name="param">参数请求体</param>
        /// <returns>列表</returns>
        [HttpGet]
        [Route("/v1/pri/PriQueryTable/getPriQueryTableList")]
        public IActionResult getPriQueryTableList([FromQuery] PagerInfo page, [FromQuery] PriQueryTable param)
        {
            var response = _PriQueryTableService.getPriQueryTableList(page, param);
            return SUCCESS(response);
        }


        /// <summary>
        /// 详情
        /// </summary>
        /// <param name="param">参数请求体</param>
        /// <returns>详情</returns>
        [HttpGet]
        [Route("/v1/pri/PriQueryTable/getPriQueryTableQuery")]
        public IActionResult getPriQueryTableQuery([FromQuery] PriQueryTable param)
        {
            var response = _PriQueryTableService.GetFirst(m => m.id == param.id).Adapt<GetPriQueryTableQueryVo>();
            return SUCCESS(response);
        }


        /// <summary>
        /// 添加
        /// </summary>
        /// <param name="param">参数请求体</param>
        /// <returns>添加</returns>
        [HttpPost]
        [Route("/v1/pri/PriQueryTable/addPriQueryTable")]
        public IActionResult addPriQueryTable([FromBody] PriQueryTable param)
        {
            var modal = param.Adapt<PriQueryTable>().ToCreate(HttpContext);
            var response = _PriQueryTableService.Add(modal);
            return SUCCESS(response);
        }


        /// <summary>
        /// 修改
        /// </summary>
        /// <param name="param">参数请求体</param>
        /// <returns>修改</returns>
        [HttpPut]
        [Route("/v1/pri/PriQueryTable/updatePriQueryTable")]
        public IActionResult updatePriQueryTable([FromBody] PriQueryTable param)
        {
            var modal = param.Adapt<PriQueryTable>().ToCreate(HttpContext);
            var response = _PriQueryTableService.Update(modal);
            return SUCCESS(response);
        }


        /// <summary>
        /// 删除
        /// </summary>
        /// <param name="id">ID</param>
        /// <returns>删除</returns>
        [HttpDelete]
        [Route("/v1/pri/PriQueryTable/deletePriQueryTable/{id}")]
        public IActionResult deletePriQueryTable(int id)
        {
            var response = _PriQueryTableService.Delete(id);
            return SUCCESS(response);
        }


          /// <param name="page">分页参数</param>
        /// <summary>
        /// 下拉框数据
        /// </summary>
        /// <param name="page">分页对象</param>
        /// <returns>下拉框数据</returns>
        [HttpGet]
        [Route("/v1/pri/PriQueryTable/getPriQueryTableDic")]
        public IActionResult getPriQueryTableDic([FromQuery] PagerInfo page)
        {
            var response = _PriQueryTableService.getPriQueryTableDic(page);
            return SUCCESS(response);
        }




    }
}