namespace Model
{
    /// <summary>
    /// 岗位信息表 sys_post
    /// </summary>
    [SugarTable("sys_post", "岗位信息表")]
    [Tenant("0")]
    public class SysPost
    {
        /// <summary>
        /// 岗位ID
        /// </summary>
        [SugarColumn(ColumnDescription = "岗位ID", IsPrimaryKey = true, IsIdentity = true, ColumnName = "post_id")]
        public long postId { get; set; }


        /// <summary>
        /// 岗位编码
        /// </summary>
        [SugarColumn(ColumnDescription = "岗位编码", Length = 64, ColumnName = "post_code")]
        public string? postCode { get; set; }


        /// <summary>
        /// 岗位名称
        /// </summary>
        [SugarColumn(ColumnDescription = "岗位名称", Length = 50, ColumnName = "post_name")]
        public string? postName { get; set; }


        /// <summary>
        /// 岗位排序
        /// </summary>
        [SugarColumn(ColumnDescription = "岗位排序", ColumnName = "post_sort")]
        public int postSort { get; set; }


        /// <summary>
        /// 岗位描述
        /// </summary>
        [SugarColumn(ColumnDescription = "岗位描述", Length = 500, ColumnName = "remark")]
        public string? remark { get; set; }


        /// <summary>
        /// 是否删除  -1：已删除  0：正常
        /// </summary>
        [SugarColumn(ColumnDescription = "是否删除  -1：已删除  0：正常", Length = 1, ColumnName = "del_flag")]
        public string? DelFlag { get; set; }


        /// <summary>
        /// 创建时间
        /// </summary>
        [SugarColumn(ColumnDescription = "创建时间", ColumnName = "create_time")]
        public DateTime? CreateTime { get; set; }


        /// <summary>
        /// 创建人
        /// </summary>
        [SugarColumn(ColumnDescription = "创建人", Length = 64, ColumnName = "create_by")]
        public string? CreateBy { get; set; }


        /// <summary>
        /// 更新时间
        /// </summary>
        [SugarColumn(ColumnDescription = "更新时间", ColumnName = "update_time")]
        public DateTime? UpdateTime { get; set; }


        /// <summary>
        /// 更新人
        /// </summary>
        [SugarColumn(ColumnDescription = "更新人", Length = 64, ColumnName = "update_by")]
        public string? UpdateBy { get; set; }



    }
}