using Mapster;


namespace Model
{
    /// <summary>
    /// 奖励发放日志 pri_log
    /// </summary>
    [SugarTable("pri_log", "奖励发放日志")]
    [Tenant("0")]
    public class PriLog
    {
        /// <summary>
        /// ID
        /// </summary>
        [SugarColumn(ColumnDescription = "ID", IsPrimaryKey = true, IsIdentity = true, ColumnName = "id")]
        public int id { get; set; }


        /// <summary>
        /// 状态
        /// </summary>
        [SugarColumn(ColumnDescription = "状态", ColumnName = "status")]
        public int status { get; set; }


        /// <summary>
        /// 排序
        /// </summary>
        [SugarColumn(ColumnDescription = "排序", ColumnName = "sort")]
        public int sort { get; set; }


        /// <summary>
        /// 版本号
        /// </summary>
        [SugarColumn(ColumnDescription = "版本号", ColumnName = "version")]
        public int version { get; set; }


        /// <summary>
        /// 创建时间
        /// </summary>
        [SugarColumn(ColumnDescription = "创建时间", ColumnName = "create_date")]
        public DateTime? createDate { get; set; }


        /// <summary>
        /// 更新时间
        /// </summary>
        [SugarColumn(ColumnDescription = "更新时间", ColumnName = "update_date")]
        public DateTime? updateDate { get; set; }


        /// <summary>
        /// 项目
        /// </summary>
        [SugarColumn(ColumnDescription = "项目", ColumnName = "project_id")]
        public int projectId { get; set; }


        /// <summary>
        /// 配置ID
        /// </summary>
        [SugarColumn(ColumnDescription = "配置ID", ColumnName = "list_id")]
        public int listId { get; set; }


        /// <summary>
        /// 批次号
        /// </summary>
        [SugarColumn(ColumnDescription = "批次号", Length = 50, ColumnName = "batch_no")]
        public string? batchNo { get; set; }


        /// <summary>
        /// 入口
        /// </summary>
        [SugarColumn(ColumnDescription = "入口", ColumnName = "prize_in")]
        public int prizeIn { get; set; }


        /// <summary>
        /// 奖励金额
        /// </summary>
        [SugarColumn(ColumnDescription = "奖励金额", ColumnName = "prize_amount")]
        public decimal prizeAmount { get; set; }


        /// <summary>
        /// 请求参数
        /// </summary>
        [SugarColumn(ColumnDescription = "请求参数", Length = 200, ColumnName = "request_param")]
        public string? requestParam { get; set; }


        /// <summary>
        /// 奖励条件明细
        /// </summary>
        [SugarColumn(ColumnDescription = "奖励条件明细", ColumnName = "step_list")]
        public string? stepList { get; set; }


        /// <summary>
        /// 入参地址
        /// </summary>
        [SugarColumn(ColumnDescription = "入参地址", Length = 200, ColumnName = "prize_in_url")]
        public string? prizeInUrl { get; set; }


        /// <summary>
        /// 出的路径
        /// </summary>
        [SugarColumn(ColumnDescription = "出的路径", Length = 200, ColumnName = "prize_out_url")]
        public string? prizeOutUrl { get; set; }


        /// <summary>
        /// 出的内容
        /// </summary>
        [SugarColumn(ColumnDescription = "出的内容", ColumnName = "prize_out_content")]
        public string? prizeOutContent { get; set; }


        /// <summary>
        /// 报错日志
        /// </summary>
        [SugarColumn(ColumnDescription = "报错日志", ColumnName = "err_log")]
        public string? errLog { get; set; }


        /// <summary>
        /// 奖励条件索引
        /// </summary>
        [SugarColumn(ColumnDescription = "奖励条件索引", Length = 100, ColumnName = "step_list_index")]
        public string? stepListIndex { get; set; }



    }
}