using Mapster;


namespace Model
{
    /// <summary>
    /// 奖励入口配置表 pri_prize_in_set
    /// </summary>
    [SugarTable("pri_prize_in_set", "奖励入口配置表")]
    [Tenant("0")]
    public class PriPrizeInSet
    {
        /// <summary>
        /// 项目
        /// </summary>
        [SugarColumn(ColumnDescription = "项目", ColumnName = "project_id")]
        public int projectId { get; set; }


        /// <summary>
        /// 更新时间
        /// </summary>
        [SugarColumn(ColumnDescription = "更新时间", ColumnName = "update_date")]
        public DateTime? updateDate { get; set; }


        /// <summary>
        /// 创建时间
        /// </summary>
        [SugarColumn(ColumnDescription = "创建时间", ColumnName = "create_date")]
        public DateTime? createDate { get; set; }


        /// <summary>
        /// 版本号
        /// </summary>
        [SugarColumn(ColumnDescription = "版本号", ColumnName = "version")]
        public int version { get; set; }


        /// <summary>
        /// 排序
        /// </summary>
        [SugarColumn(ColumnDescription = "排序", ColumnName = "sort")]
        public int sort { get; set; }


        /// <summary>
        /// 状态
        /// </summary>
        [SugarColumn(ColumnDescription = "状态", ColumnName = "status")]
        public int status { get; set; }


        /// <summary>
        /// ID
        /// </summary>
        [SugarColumn(ColumnDescription = "ID", IsPrimaryKey = true, IsIdentity = true, ColumnName = "id")]
        public int id { get; set; }


        /// <summary>
        /// 指定奖励配置
        /// </summary>
        [SugarColumn(ColumnDescription = "指定奖励配置", Length = 200, ColumnName = "prize_list_ids")]
        public string? prizeListIds { get; set; }


        /// <summary>
        /// 备注
        /// </summary>
        [SugarColumn(ColumnDescription = "备注", Length = 200, ColumnName = "note")]
        public string? note { get; set; }


        /// <summary>
        /// MQ队列名
        /// </summary>
        [SugarColumn(ColumnDescription = "MQ队列名", Length = 50, ColumnName = "mq_queue_name")]
        public string? mqQueueName { get; set; }



    }
}