using Mapster;


namespace Model
{
    /// <summary>
    /// 奖励项目 pri_project
    /// </summary>
    [SugarTable("pri_project", "奖励项目")]
    [Tenant("0")]
    public class PriProject
    {
        /// <summary>
        /// ID
        /// </summary>
        [SugarColumn(ColumnDescription = "ID", IsPrimaryKey = true, IsIdentity = true, ColumnName = "id")]
        public int id { get; set; }


        /// <summary>
        /// 状态
        /// </summary>
        [SugarColumn(ColumnDescription = "状态", ColumnName = "status")]
        public int status { get; set; }


        /// <summary>
        /// 排序
        /// </summary>
        [SugarColumn(ColumnDescription = "排序", ColumnName = "sort")]
        public int sort { get; set; }


        /// <summary>
        /// 版本号
        /// </summary>
        [SugarColumn(ColumnDescription = "版本号", ColumnName = "version")]
        public int version { get; set; }


        /// <summary>
        /// 创建时间
        /// </summary>
        [SugarColumn(ColumnDescription = "创建时间", ColumnName = "create_date")]
        public DateTime? createDate { get; set; }


        /// <summary>
        /// 更新时间
        /// </summary>
        [SugarColumn(ColumnDescription = "更新时间", ColumnName = "update_date")]
        public DateTime? updateDate { get; set; }


        /// <summary>
        /// 项目名称
        /// </summary>
        [SugarColumn(ColumnDescription = "项目名称", Length = 50, ColumnName = "project_name")]
        public string? projectName { get; set; }


        /// <summary>
        /// 项目介绍
        /// </summary>
        [SugarColumn(ColumnDescription = "项目介绍", Length = 200, ColumnName = "project_detail")]
        public string? projectDetail { get; set; }


        /// <summary>
        /// 调用方式
        /// </summary>
        [SugarColumn(ColumnDescription = "调用方式", Length = 50, ColumnName = "request_mode")]
        public string? requestMode { get; set; }


        /// <summary>
        /// 是否通知
        /// </summary>
        [SugarColumn(ColumnDescription = "是否通知", ColumnName = "notice_flag")]
        public bool noticeFlag { get; set; }


        /// <summary>
        /// 通知地址
        /// </summary>
        [SugarColumn(ColumnDescription = "通知地址", Length = 200, ColumnName = "notice_url")]
        public string? noticeUrl { get; set; }


        /// <summary>
        /// 请求地址
        /// </summary>
        [SugarColumn(ColumnDescription = "请求地址", Length = 200, ColumnName = "request_url")]
        public string? requestUrl { get; set; }


        /// <summary>
        /// 返回数据类型
        /// </summary>
        [SugarColumn(ColumnDescription = "返回数据类型", Length = 20, ColumnName = "return_type")]
        public string? returnType { get; set; }


        /// <summary>
        /// 日志开关
        /// </summary>
        [SugarColumn(ColumnDescription = "日志开关", ColumnName = "log_flag")]
        public bool logFlag { get; set; }



    }
}