using Mapster;


namespace Model
{
    /// <summary>
    /// 条件匹配表 pri_query_table
    /// </summary>
    [SugarTable("pri_query_table", "条件匹配表")]
    [Tenant("0")]
    public class PriQueryTable
    {
        /// <summary>
        /// ID
        /// </summary>
        [SugarColumn(ColumnDescription = "ID", IsPrimaryKey = true, IsIdentity = true, ColumnName = "id")]
        public int id { get; set; }


        /// <summary>
        /// 状态
        /// </summary>
        [SugarColumn(ColumnDescription = "状态", ColumnName = "status")]
        public int status { get; set; }


        /// <summary>
        /// 排序
        /// </summary>
        [SugarColumn(ColumnDescription = "排序", ColumnName = "sort")]
        public int sort { get; set; }


        /// <summary>
        /// 版本号
        /// </summary>
        [SugarColumn(ColumnDescription = "版本号", ColumnName = "version")]
        public int version { get; set; }


        /// <summary>
        /// 创建时间
        /// </summary>
        [SugarColumn(ColumnDescription = "创建时间", ColumnName = "create_date")]
        public DateTime? createDate { get; set; }


        /// <summary>
        /// 更新时间
        /// </summary>
        [SugarColumn(ColumnDescription = "更新时间", ColumnName = "update_date")]
        public DateTime? updateDate { get; set; }


        /// <summary>
        /// 查询表
        /// </summary>
        [SugarColumn(ColumnDescription = "查询表", Length = 50, ColumnName = "table_en_name")]
        public string? tableEnName { get; set; }


        /// <summary>
        /// 项目
        /// </summary>
        [SugarColumn(ColumnDescription = "项目", ColumnName = "project_id")]
        public int projectId { get; set; }


        /// <summary>
        /// 说明
        /// </summary>
        [SugarColumn(ColumnDescription = "说明", Length = 100, ColumnName = "summary")]
        public string? summary { get; set; }


        /// <summary>
        /// 查询库
        /// </summary>
        [SugarColumn(ColumnDescription = "查询库", ColumnName = "database_id")]
        public int databaseId { get; set; }


        /// <summary>
        /// 起始数据
        /// </summary>
        [SugarColumn(ColumnDescription = "起始数据", ColumnName = "start_data_flag")]
        public bool startDataFlag { get; set; }


        /// <summary>
        /// 每次读取数量
        /// </summary>
        [SugarColumn(ColumnDescription = "每次读取数量", ColumnName = "step_count")]
        public int stepCount { get; set; }


        /// <summary>
        /// 排序
        /// </summary>
        [SugarColumn(ColumnDescription = "排序", Length = 200, ColumnName = "order_by")]
        public string? orderBy { get; set; }


        /// <summary>
        /// 自定义sql查询
        /// </summary>
        [SugarColumn(ColumnDescription = "自定义sql查询", ColumnName = "custom_sql")]
        public string? customSql { get; set; }



    }
}