using System;
using System.ComponentModel.DataAnnotations;
using Model.Base;

namespace Dto
{
    /// <summary>
    /// 设置请求地址
    /// </summary>
    public class ApiInfoSetRouterDto
    {
        /// <summary>
        /// 接口主机头
        /// </summary>
        [Required(ErrorMessage = "接口主机头不能为空")]
        public string? apiHost { get; set; }


        /// <summary>
        /// 接口端口号
        /// </summary>
        [Required(ErrorMessage = "接口端口号不能为空")]
        public int apiPort { get; set; }


        /// <summary>
        /// 接口路由
        /// </summary>
        [Required(ErrorMessage = "接口路由不能为空")]
        public string? apiRouter { get; set; }


        /// <summary>
        /// ID
        /// </summary>
        public int id { get; set; }



    }
}
