using Attribute;
using Model;
using Model.Base;
using Repository;
using Service;
using Microsoft.AspNetCore.Mvc;
using Vo.Admin;


namespace Services
{
    /// <summary>
    /// 奖励金额设置Service业务层处理
    /// </summary>
    [AppService(ServiceType = typeof(IPriListAmountSetService), ServiceLifetime = LifeTime.Transient)]
    public class PriListAmountSetService : BaseService<PriListAmountSet>, IPriListAmountSetService
    {
        /// <summary>
        /// 奖励金额设置-列表
        /// </summary>
        /// <param name="param">参数请求体</param>
        /// <param name="page">分页参数</param>
        /// <returns>列表</returns>
        public PagedInfo<GetPriListAmountSetListVo> getPriListAmountSetList([FromQuery] PagerInfo page, [FromQuery] PriListAmountSet param)
        {
            //拼装查询条件
            var predicate = Expressionable.Create<PriListAmountSet>();
            predicate = predicate.AndIF(param.listId > 0, m => m.listId == param.listId);
            predicate = predicate.AndIF(!string.IsNullOrEmpty(param.prizeSourceField), m => m.prizeSourceField.Contains(param.prizeSourceField));
            var response = Queryable()
                .Where(predicate.ToExpression())
                .OrderByDescending(m => m.id)
                .ToPage<PriListAmountSet, GetPriListAmountSetListVo>(page);
            return response;
        }



    }
}
