using Attribute;
using Model;
using Model.Base;
using Repository;
using Service;
using Microsoft.AspNetCore.Mvc;
using Vo.Admin;


namespace Services
{
    /// <summary>
    /// 奖励发放日志Service业务层处理
    /// </summary>
    [AppService(ServiceType = typeof(IPriLogService), ServiceLifetime = LifeTime.Transient)]
    public class PriLogService : BaseService<PriLog>, IPriLogService
    {
        /// <summary>
        /// 奖励发放日志-列表
        /// </summary>
        /// <param name="param">参数请求体</param>
        /// <param name="page">分页参数</param>
        /// <returns>列表</returns>
        public PagedInfo<GetPriLogListVo> getPriLogList([FromQuery] PagerInfo page, [FromQuery] PriLog param)
        {
            //拼装查询条件
            var predicate = Expressionable.Create<PriLog>();
            predicate = predicate.AndIF(param.listId > 0, m => m.listId == param.listId);
            predicate = predicate.AndIF(!string.IsNullOrEmpty(param.batchNo), m => m.batchNo.Contains(param.batchNo));
            var response = Queryable()
                .Where(predicate.ToExpression())
                .OrderByDescending(m => m.id)
                .ToPage<PriLog, GetPriLogListVo>(page);
            return response;
        }



    }
}
