using Attribute;
using Model;
using Model.Base;
using Repository;
using Service;
using Microsoft.AspNetCore.Mvc;
using Vo.Admin;


namespace Services
{
    /// <summary>
    /// 奖励入口配置表Service业务层处理
    /// </summary>
    [AppService(ServiceType = typeof(IPriPrizeInSetService), ServiceLifetime = LifeTime.Transient)]
    public class PriPrizeInSetService : BaseService<PriPrizeInSet>, IPriPrizeInSetService
    {
        /// <summary>
        /// 奖励入库表-列表
        /// </summary>
        /// <param name="param">参数请求体</param>
        /// <param name="page">分页参数</param>
        /// <returns>列表</returns>
        public PagedInfo<GetPriPrizeInSetListVo> getPriPrizeInSetList([FromQuery] PagerInfo page, [FromQuery] PriPrizeInSet param)
        {
            //拼装查询条件
            var predicate = Expressionable.Create<PriPrizeInSet>();
            predicate = predicate.AndIF(param.projectId > 0, m => m.projectId == param.projectId);
            var response = Queryable()
                .Where(predicate.ToExpression())
                .OrderByDescending(m => m.id)
                .ToPage<PriPrizeInSet, GetPriPrizeInSetListVo>(page);
            return response;
        }
    }
}
